#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <unistd.h>

#define min(a,b) ((a<b)?a:b)
#define max(a,b) ((a>b)?a:b)
#define absm(a) ((a)<(0) ? (-(a)):(a))
#define log2(a) (log((float) a)/log(2.0))

/*static int erosion_strel[2][37]={{-1,0,1,-2,-1,0,1,2,-3,-2,-1,0,1,2,3,-3,-2,-1,0,1,2,3,-3,-2,-1,0,1,2,3,-2,-1,0,1,2,-1,0,1},
{-3,-3,-3,-2,-2,-2,-2,-2,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,2,2,2,2,2,3,3,3}};*/

/*define structuring elements for erosion operation*/
/*static int erosion_strel[37]={-1537,-1536,-1535,-1026,-1025,-1024,-1023,-1022,-515,-514,-513,-512,-511,-510,-509,
  -3,-2,-1,0,1,2,3,509,510,511,512,513,514,515,1022,1023,1024,1025,1026,1535,1536,1537};*/

static int erosion_strel[37]={-1921,-1920,-1919,-1282,-1281,-1280,-1279,-1278,-643,-642,-641,-640,-639,-638,-637,
  -3,-2,-1,0,1,2,3,637,638,639,640,641,642,643,1278,1279,1280,1281,1282,1919,1920,1921};

/*static int erosion_strel[5]={-640,-1,0,1,640};*/

/*compute thresholds for the classification of depth samples*/
void compute_thr(unsigned short* depth, int N, unsigned short* thrL, unsigned short* thrU, int width, int height)
{

int i,x, y,cand,cnt_null,cnt_not_null,iter;
//unsigned int* hist_dvalues;
double* thr_new;
int* thr_cnt;
unsigned short* thr;


//hist_dvalues=(unsigned int*) calloc(2048,sizeof(int));

thr=(unsigned short*) malloc(sizeof(unsigned short)*N);
thr_new=(double*) calloc(N,sizeof(double));
thr_cnt=(int*) calloc(N,sizeof(int));



/*for (i=0;i<(width*height);i++)
	{
	x=depth[i];
	hist_dvalues[x]=hist_dvalues[x]+1;
	}

free(hist_dvalues);*/

for (i=0;i<N;i++)
	{
	x=(int) ((((double) rand())/RAND_MAX)*(width*height));
	thr[i]=depth[x];
	}

/*sort*/
for (x=0;x<(N-1);x++)
	{
	for (y=x+1;y<N;y++)
		if (thr[x]>thr[y])
			{
			i=thr[y];
			thr[y]=thr[x];
			thr[x]=i;
			}
	}

for (iter=0;iter<2;iter++)
	{
	for (i=0;i<N;i++)
		{
		thr_new[i]=0;
		thr_cnt[i]=0;
		}

	for (x=0;x<(width*height);x++)
		{
		cand=0;
		for (y=0;(y<N)&(depth[x]>thr[y]);y++) ;
		
		if ((y<N)&&(y>0))
			{
			if ((thr[y]-depth[x])<(thr[y-1]-depth[x]))
				cand=y;
			else
				cand=y-1;
			}
		else
		if (y==0)
			cand=y;
		else
			cand=N-1;

		thr_new[cand]=thr_new[cand]+depth[x];
		thr_cnt[cand]++;
		}
	
	cnt_not_null=0;
	cand=0;
	cnt_null=0;
	for (i=0;i<N;i++)
		if (thr_cnt[i]>0)
			{
			thr[i]=(int) (thr_new[i]/thr_cnt[i]);
			if (thr_cnt[i]>cnt_not_null)
				{
				cand=i;
				cnt_not_null=thr_cnt[i];
				}
			}
		else
			cnt_null++;

	if ((cand>0)&(cand<(N-1)))
		{
		y=(thr[cand+1] - thr[cand-1])/(cnt_null+1);
		x=thr[cand+1];
		}
	else
	if (cand==0)
		{
		y=(0 - thr[cand])/(cnt_null+1);
		x=0;
		}
	else
		{
		y=(1024 - thr[cand-1])/(cnt_null+1);
		x=thr[cand-1];
		}
		 
	cnt_null=0;
	for (i=0;i<N;i++)
		if ((thr_cnt[i]==0)|(i==cand))
			{
			thr[i]=x+cnt_null*y;
			cnt_null++;	
			}

	/*sort*/
	for (x=0;x<(N-1);x++)
		{
		for (y=x+1;y<N;y++)
			if (thr[x]>thr[y])
				{
				i=thr[y];
				thr[y]=thr[x];
				thr[x]=i;
				}
		}	
	
	}

thrL[0]=1;
thrU[N-1]=1024;

for (i=1;i<N;i++)
	thrL[i]=thrU[i-1]=(thr[i]+thr[i-1])/2;
		


free(thr); 
free(thr_new); 
free(thr_cnt);
}


void compute_lbg(unsigned char* color, unsigned short* depth, unsigned char* mask,
			int N, int width, int height)

{

int i,x,y,iter,pt_col,pt_depth,min_diff,diff1,diff2,cand,max_diff,cnt_null;
unsigned char* centers;
double* centers_new;
unsigned int* centers_cnt;

centers=(unsigned char*) malloc(sizeof(unsigned char)*(2*N));
centers_new=(double*) calloc(N*2,sizeof(double));
centers_cnt=(unsigned int*) calloc(N*2,sizeof(unsigned int));

pt_col=0;
pt_depth=N;
for (i=0;i<N;i++)
	{
	x=(int) ((((double) rand())/RAND_MAX)*(width*height));
	centers[pt_col]=color[x];
	centers[pt_depth]=depth[x];
	pt_col++;
	pt_depth++;
	}


for (iter=0; iter < 10 ; iter++)
  {
  for (i=0;i<(2*N);i++)
	{
	centers_new[i]=0;
	centers_cnt[i]=0;
	}

  for (x=0;x<(width*height);x++)
	{
	cand=0;
	min_diff=1000000;
	pt_col=0;
	pt_depth=N;
	cand=0;
	for (i=0 ; i<N ; i++,pt_col++,pt_depth++) 
	{
	  diff1=absm(depth[x]-centers[pt_depth]);
	  diff2=absm(color[x]-centers[pt_col]);
	  diff1=diff1>>4;
	  diff1=diff1+diff2;
	  if (diff1<min_diff)
	  {
	    cand=i;
	    min_diff=diff1;
	  }   
	}
	
	mask[x]=cand;
	centers_new[cand]=centers_new[cand]+color[x];
	centers_new[cand+N]=centers_new[cand+N]+depth[x];
	centers_cnt[cand]++;
	}
	
	cnt_null=0;
	for (i=0;i<N;i++)
	   if (centers_cnt[i]>0)
	   {
	    centers[i]=(unsigned char) (((double) centers_new[i])/centers_cnt[i]);
	    centers[i+N]=(unsigned short) (((double) centers_new[i+N])/centers_cnt[i]);
	   }
	   else
	     cnt_null++;
	
	
	if (cnt_null>0)
	{
	max_diff=0;
	cand=0;
	 for (i=0;i<N;i++)
	   if (centers_cnt[i]>max_diff)
	   {
	    max_diff=centers_cnt[i];
	    cand=i;
	   }
	   
	diff1=10000;
	diff2=10000;
	pt_col=0;
	pt_depth=N;
	for (i=0;i<N;i++,pt_col++,pt_depth++)
	   if (centers_cnt[i]>0)
	   {
	    x=absm(centers[pt_col]-centers[cand]);
	    if (x<diff1) diff1=x;
	    x=absm(centers[pt_depth]-centers[cand+N]);
	    if (x<diff2) diff2=x;
	   }
	   
	x=centers[cand]-diff1;
	y=centers[cand+N]-diff2;
	
	diff1=diff1/(cnt_null+1);
	diff2=diff2/(cnt_null+1);
	
	x=x+diff1;
	y=y+diff2;
	 
	pt_col=0;
	pt_depth=N;
	cnt_null=1;
	for (i=0;i<N;i++,pt_col++,pt_depth++)
	   if (centers_cnt[i]==0)
	   {
	    centers[pt_col]=x;
	    centers[pt_depth]=y;
	    x=x+diff1;
	    y=y+diff2;
	   }
	
	}
  }
  

free(centers);
free(centers_new);
free(centers_cnt);
}


/*void erase_depth(unsigned short* depth, unsigned char* gradDepth, unsigned short* depth_out,
			int width, int height)

{
  
  int x,y,pos,size_im,up_av,down_av,left_av,right_av,subx,subx2,suby,suby2,dd;
  
  size_im=width*height;
  
  for (pos=0;pos<size_im;pos++)
    depth_out[pos]=depth[pos];
  
  for (pos=0;pos<size_im;pos++)
  {
   if (((depth[pos]<100)||(gradDepth[pos]>0))||(depth[pos]>1100))
   {
    x=pos%width;
    y=pos/width;
    
    for (dd=0;dd<3;dd++)
    {
      subx=dd+1;
      subx2=width-subx;
      suby=width*(dd+1);
      suby2=size_im-suby;
      
      if (x>subx)
	depth_out[pos-subx]=0;
    
      if (x<subx2)
	depth_out[pos+subx]=0;
    
      if (pos>suby)
	depth_out[pos-suby]=0;
    
      if (y<suby2)
	depth_out[pos+suby]=0;
    
    }
    
    depth_out[pos]=0;
    }
  }
  
}*/

void erase_depth(unsigned short* depth, unsigned char* gradDepth, unsigned short* depth_out,
			int width, int height)

{
  
  int x,pos,pos2,size_im;
  
  size_im=width*height;
  
  for (pos=0;pos<size_im;pos++)
    depth_out[pos]=depth[pos];
  
  for (pos=0;pos<size_im;pos++)
  {
   if (((depth[pos]>10)&(gradDepth[pos]==0))&(depth[pos]<1100))
   {
 
    for (x=0;x<37;x++)
    {
      pos2=pos-erosion_strel[x];
      if (depth[pos2]==0)
	break;
    }
    
    if (x<37) 
      depth_out[pos]=0;
    
   }
    else
      depth_out[pos]=0;
  }
  
}

void propagate_depth(unsigned short* depth, unsigned char* color, unsigned char* gradColor, unsigned short* depth_out, 
			int width, int height, int thgrad)

{
  
  int x,y,pos,size_im,up_av,down_av,left_av,right_av,diff;
  float wa,wb,wc,wd,wtot,val;
  
  size_im=width*height;
  
  for (pos=0;pos<size_im;pos++)
  {
   if (depth[pos]==0)
   {
     
     //left reference
     x=(pos%width);
     if (x>0)
     {
      left_av=pos-1;
      x=x-1;
     }
     else
       left_av=-1;
     
     if (left_av>-1)
     {
      for (;x>0;left_av--,x--)
	if ((depth[left_av]>0)|(gradColor[left_av]>thgrad)) break;
	
	if (depth[left_av]>0)
	    wa=(pos-left_av);
	else
	    wa=0;
     }
     else
       wa=0;
     
     
     //right reference
     x=(pos%width);
     if (x<(width-1))
     {
      right_av=pos+1;
      x=x+1;
     }
     else
       right_av=-1;
     
     if (right_av>-1)
     {
	for (;x<(width-1);right_av++,x++)
	  if ((depth[right_av]>0)|(gradColor[right_av]>thgrad)) break;
       
	if (depth[right_av]>0)
	    wb=(right_av-pos);
	else
	    wb=0;
     } 
     else
       wb=0;
     
     
     //upper reference
     if (pos>(width-1))
      up_av=pos-width;
     else
      up_av=-1; 
     
     if (up_av>-1)
     {
	for (;up_av>(width-1);up_av-=width)
	  if ((depth[up_av]>0)|(gradColor[up_av]>thgrad)) break;
	
	if (depth[up_av]>0)
	  wc=(pos-up_av)/width;
	else
	  wc=0;
     }
     else
       wc=0;
     
     //bottom reference
      if (pos<(size_im-width-1))
	down_av=pos+width;
      else
	down_av=-1; 

     if (down_av>-1)
     {
	for (;down_av<size_im;down_av+=width)
	  if ((depth[down_av]>0)|(gradColor[down_av]>thgrad)) break;
       
	if (depth[down_av]>0)
	  wd=(down_av-pos)/width;
	else
	  wd=0;
       
     }
     else
       wd=0;
     
     /*if (wa>10) wa=0;
     if (wb>10) wb=0;
     if (wc>10) wc=0;
     if (wd>10) wd=0;*/

	
	wtot=(wa+wb+wc+wd);
	
	if (wtot>0)
	{
	if (wa>0) wa=wtot/wa;
	if (wb>0) wb=wtot/wb;
	if (wc>0) wc=wtot/wc;
	if (wd>0) wd=wtot/wd;
	
	wtot=(wa+wb+wc+wd);
	
	if (wa>0) wa=wa/wtot;
	if (wb>0) wb=wb/wtot;
	if (wc>0) wc=wc/wtot;
	if (wd>0) wd=wd/wtot;
	  
	val=0;
	if (wa>0)
	  val=wa*depth[left_av];
	if (wb>0)
	  val=val+wb*depth[right_av];
	if (wc>0)
	  val=val+wc*depth[up_av];
	if (wd>0)
	  val=val+wd*depth[down_av];
	
	depth_out[pos]=(unsigned short) val;
       
	}
   }
   else
     depth_out[pos]=(unsigned short) depth[pos];
  }
  
}
