#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <unistd.h>
#include <sys/time.h>


 
#define BLOCK_SIZE 16
#define MAX_IMG_PEL 255
#define min(a,b) ((a<b)?a:b)
#define max(a,b) ((a>b)?a:b)
#define absm(a) ((a)<(0) ? (-(a)):(a))
#define log2(a) (log((float) a)/log(2.0))

#define COMP_TIME 0

 int** mvvet;

unsigned char *colorM;
unsigned short *depthM;
unsigned short *depthM_denoise;
unsigned char* maskM;
unsigned char* gradColorM;
unsigned int** vet_pos;
float scal_par;

unsigned short* thr_up;
unsigned short* thr_down;
int Nthr,srw;

void init_denoise(int width, int height, int nt) {

int y;


Nthr=nt;
thr_up=(unsigned short*) malloc(sizeof(unsigned short)*Nthr);
thr_down=(unsigned short*) malloc(sizeof(unsigned short)*Nthr);



maskM=(unsigned char*) malloc(sizeof(unsigned char)*(width*height));
for (y=0;y<(width*height);y++)
	maskM[y]=0;
gradColorM=(unsigned char*) malloc(sizeof(unsigned char)*(width*height));
for (y=0;y<(width*height);y++)
	gradColorM[y]=0;
depthM=(unsigned short*) malloc(sizeof(unsigned short)*(width*height));
depthM_denoise=(unsigned short*) malloc(sizeof(unsigned short)*(width*height));
for (y=0;y<(width*height);y++)
	depthM_denoise[y]=0;
colorM=(unsigned char*) malloc(sizeof(unsigned char)*(width*height));

vet_pos=(unsigned int**) malloc(sizeof(unsigned int*)*4);
for (y=0;y<4;y++)
	vet_pos[y]=(unsigned int*) malloc(sizeof(unsigned int)*((width>>1)*(height>>1)+Nthr*3));

}

void free_denoise(void) {

int y;

free(thr_up);
free(thr_down);
free(maskM);
free(gradColorM);
free(colorM);
free(depthM);
free(depthM_denoise);

for (y=0;y<4;y++)
	free(vet_pos[y]);
free(vet_pos);

}
		


		

void compute_sobel(unsigned char* color, unsigned short* depth, 
			unsigned char* masks, unsigned char* colorGrad, 
				int width, int height,int thD)
{

int x, y, grady, gradx,pos,pos1,pos2;

for (y=0;y<(width*height);y++)
		masks[y]=0;

pos=width+1;
for (y=1;y<(height-1);y++)
	for (x=1;x<(width-1);x++,pos++)
		{
		grady=0;
		gradx=0;
		pos1=pos-1-width;
		pos2=pos+1-width;
		gradx=color[pos1] - color[pos2] ;
		pos1=pos1+width;
		pos2=pos2+width;
		gradx=gradx+((color[pos1] - color[pos2])<<1) ;
		pos1=pos1+width;
		pos2=pos2+width;
		gradx=gradx+(color[pos1] - color[pos2]);
		gradx=(gradx<0)?-gradx:gradx;
		gradx=gradx>>1;

		pos1=pos-1-width;
		pos2=pos-1+width;
		grady=color[pos1] - color[pos2] ;
		pos1++;
		pos2++;
		grady=grady+((color[pos1] - color[pos2])<<1) ;
		pos1++;
		pos2++;
		grady=grady+(color[pos1] - color[pos2]);
		grady=(grady<0)?-grady:grady;
		grady=grady>>1;

		gradx=gradx+grady;
		gradx=(gradx>255)?255:(gradx<0)?0:gradx;
		colorGrad[pos]=gradx;

		grady=0;
		gradx=0;
		pos1=pos-1-width;
		pos2=pos+1-width;
		if ((depth[pos1]>0)&(depth[pos2]>0))
		{
		  gradx=depth[pos1] - depth[pos2] ;
		
		  pos1=pos1+width;
		  pos2=pos2+width;
		  if ((depth[pos1]>0)&(depth[pos2]>0))
		  {
		    gradx=gradx+((depth[pos1] - depth[pos2])*2) ;
		    pos1=pos1+width;
		    pos2=pos2+width;
		    if ((depth[pos1]>0)&(depth[pos2]>0))
		    {
		      gradx=gradx+(depth[pos1] - depth[pos2]);
		      gradx=(gradx<0)?-gradx:gradx;
		      gradx=gradx>>thD;
		    }
		    else
		      gradx=0;
		  }
		  else
		      gradx=0;
		}
		else
		      gradx=0;
		    

		pos1=pos-1-width;
		pos2=pos-1+width;
		if ((depth[pos1]>0)&(depth[pos2]>0))
		{
		  grady=depth[pos1] - depth[pos2] ;
		  pos1++;
		  pos2++;
		  
		  if ((depth[pos1]>0)&(depth[pos2]>0))
		  {
		    grady=grady+((depth[pos1] - depth[pos2])*2) ;
		    pos1++;
		    pos2++;
		
		    if ((depth[pos1]>0)&(depth[pos2]>0))
		    {
		      grady=grady+(depth[pos1] - depth[pos2]);
		      grady=(grady<0)?-grady:grady;
		      grady=grady>>thD;
		    }
		    else
		      grady=0;
		  }
		  else
		      grady=0;
		}
		else
		      grady=0;
		
		if (((gradx!=0)|(grady!=0))&(depth[pos]>0))
			masks[pos]=1;

		}

}



void compute_pixel_lines(unsigned short* depth, unsigned char* mask, unsigned char* gradColor, unsigned short* depth_out, 
			int width, int height)

{

int x,y,pos,c,pos_num0,pos_point0,h2,w2,w23;
int pos_num1,pos_point1,pos_num2,pos_point2,pos_num3,pos_point3;

h2=height>>1;
w2=width>>1;
w23=w2+1;

pos_num0=pos_num1=pos_num2=pos_num3=0;
pos_point0=pos_point1=pos_point2=pos_point3=1;
for (c=0;c<Nthr;c++)
{

vet_pos[0][pos_num0]=0;

pos=1;
for (y=1;y<h2;y++,pos+=w23)
	for (x=1;x<w2;x++,pos++)
		{
		if (((depth[pos]>=thr_down[c]) & (depth[pos]<thr_up[c]))&(mask[pos]>0))
			{
			vet_pos[0][pos_num0]++;
			vet_pos[0][pos_point0++]=pos;		
			}	
		}
pos_num0=pos_point0;
pos_point0++;


pos=w2;
vet_pos[1][pos_num1]=0;
for (y=1;y<h2;y++,pos+=w23)
	for (x=w2;x<(width-1);x++,pos++)
		{
		if (((depth[pos]>=thr_down[c]) & (depth[pos]<thr_up[c]))&(mask[pos]>0))
			{
			vet_pos[1][pos_num1]++;
			vet_pos[1][pos_point1++]=pos;		
			}	
		}
pos_num1=pos_point1;
pos_point1++;

pos=h2*width+1;
vet_pos[2][pos_num2]=0;
for (y=h2;y<(height-1);y++,pos+=w23)
	for (x=1;x<w2;x++,pos++)
		{
		if (((depth[pos]>=thr_down[c]) & (depth[pos]<thr_up[c]))&(mask[pos]>0))
			{
			vet_pos[2][pos_num2]++;
			vet_pos[2][pos_point2++]=pos;		
			}	
		}
pos_num2=pos_point2;
pos_point2++;

pos=h2*width+w2;
vet_pos[3][pos_num3]=0;
for (y=h2;y<(height-1);y++,pos+=w23)
	for (x=w2;x<(width-1);x++,pos++)
		{
		if (((depth[pos]>=thr_down[c]) & (depth[pos]<thr_up[c]))&(mask[pos]>0))
			{
			vet_pos[3][pos_num3]++;
			vet_pos[3][pos_point3++]=pos;		
			}	
		}
pos_num3=pos_point3;
pos_point3++;


}



    
	
}


void compute_pred(unsigned short* depth, unsigned char* mask, unsigned char* gradColor, unsigned short* depth_out, 
			int width, int height)

{

int i,j,c,dx,dy,dym,limits,num_pts,tot_px, best_dx, best_dy, pos_num, pos_point;
float val0,val1,val2,val3,best_val;
int pos,x,y,w2,h2,w23,wins_h,wins_w;
int pos_num0,pos_point0,pos_num1,pos_point1,pos_num2,pos_point2,pos_num3,pos_point3;
unsigned short ddd;

pos_num0=pos_num1=pos_num2=pos_num3=0;
pos_point0=pos_point1=pos_point2=pos_point3=1;

w2=width/2;
h2=height/2;
w23=w2+1;

limits=width*height;
for (x=0;x<limits;x++)
	depth_out[x]=depth[x];

wins_h=4;
wins_w=16;

for (c=0;c<Nthr;c++)
{

wins_h=(int) (4.0*(((float) (1024.0 - thr_down[c]))/1024.0));
wins_w=(int) (16.0*(((float) (1024.0 - thr_down[c]))/1024.0));;

best_val=0;
dym=-wins_h*width;
best_dx=0;
best_dy=0;
for (dy=-wins_h;dy<wins_h;dy++,dym+=width)
	for (dx=-wins_w;dx<wins_w;dx++)
		{
		val0=val1=val2=val3=0;

		pos_num=pos_num0;
		pos_point=pos_point0;
		tot_px=0;
		num_pts=vet_pos[0][pos_num];
		for (i=0;i<num_pts;i++,pos_point++)
			{
			j=vet_pos[0][pos_point];
			j=j+dym+dx;
			if ((j>0)&(j<limits))
				{
				val0=val0+gradColor[j];
				tot_px++;
				}
			}
		
		pos_num=pos_num1;
		pos_point=pos_point1;
		num_pts=vet_pos[1][pos_num];
		for (i=0;i<num_pts;i++,pos_point++)
			{
			j=vet_pos[1][pos_point];
			j=j+dym-dx;
			if ((j>0)&(j<limits))
				{
				val1=val1+gradColor[j];
				tot_px++;
				}
			}	

		pos_num=pos_num2;
		pos_point=pos_point2;
		num_pts=vet_pos[2][pos_num];
		for (i=0;i<num_pts;i++,pos_point++)
			{
			j=vet_pos[2][pos_point];
			j=j-dym+dx;
			if ((j>0)&(j<limits))
				{
				val2=val2+gradColor[j];
				tot_px++;
				}
			}

		pos_num=pos_num3;
		pos_point=pos_point3;
		num_pts=vet_pos[3][pos_num];
		for (i=0;i<num_pts;i++,pos_point++)
			{
			j=vet_pos[2][pos_point];
			j=j-dym-dx;
			if ((j>0)&(j<limits))
				{
				val3=val3+gradColor[j];
				tot_px++;
				}
			}

		//val1=(val1+val2+val3+val0)/tot_px;
		val1=(val1+val2+val3+val0);
		/*if (dx!=0)
			dist_mv=20.0/((float) ((dx<0)?-dx:dx));
		else
			dist_mv=20.0;
		
		if (dy!=0)
			dist_mv=dist_mv+20.0/((float) ((dy<0)?-dy:dy));
		else
			dist_mv=dist_mv+20.0;
		val1=val1+dist_mv;*/

		if (val1>best_val)
			{
			best_dx=dx;
			best_dy=dy;
			best_val=val1;
			}
		}

dym=best_dy*width;

pos_num=pos_num0;
pos_point=pos_point0;
num_pts=vet_pos[0][pos_num];
pos_point+=num_pts;
pos_point0=pos_point;
pos_num0=pos_point0;
pos_point0++;

pos=0;
for (y=1;y<h2;y++,pos+=w23)
	for (x=1;x<w2;x++,pos++)
		{
		if ((depth[pos]>=thr_down[c]) & (depth[pos]<thr_up[c]))
			{
			j=pos+dym+best_dx;
			ddd=depth[pos];

			val1=((float) best_dx)*((1084+ddd)/(x-264.46));
			val2=((float) best_dy)*((1084+ddd)/(y-205.21));

			val1=(val1+val2)/2;

			if ((ddd>0)&(absm(val1/ddd)<.3))
			{
			ddd=(unsigned short) (ddd-val1);
			if ((j>0)&(j<limits))
				depth_out[j]=ddd;
			}	
			}
		}


pos_num=pos_num1;
pos_point=pos_point1;
num_pts=vet_pos[1][pos_num];
pos_point+=num_pts;
pos_point1=pos_point;
pos_num1=pos_point1;
pos_point1++;
pos=w2;
for (y=1;y<h2;y++,pos+=w23)
	for (x=w2;x<(width-1);x++,pos++)
		{
		if ((depth[pos]>=thr_down[c]) & (depth[pos]<thr_up[c]))
			{
			j=pos+dym-best_dx;
			ddd=depth[pos];
			
			val1=((float) best_dx)*((1084+ddd)/(x-264.46));
			val2=((float) best_dy)*((1084+ddd)/(y-205.21));

			val1=(val1+val2)/2;
			
			if ((ddd>0)&(absm(val1/ddd)<.3))
			{
			ddd=(unsigned short) (ddd-val1);
			if ((j>0)&(j<limits))
				depth_out[j]=ddd;
			}
			}	
		}



pos_num=pos_num2;
pos_point=pos_point2;
num_pts=vet_pos[2][pos_num];
pos_point+=num_pts;
pos_point2=pos_point;
pos_num2=pos_point2;
pos_point2++;
pos=h2*width+1;
for (y=h2;y<(height-1);y++,pos+=w23)
	for (x=1;x<w2;x++,pos++)
		{
		if ((depth[pos]>=thr_down[c]) & (depth[pos]<thr_up[c]))
			{
			j=pos-dym+best_dx;
			ddd=depth[pos];
			
			val1=((float) best_dx)*((1084+ddd)/(x-264.46));
			val2=((float) best_dy)*((1084+ddd)/(y-205.21));

			val1=(val1+val2)/2;
			
			if ((ddd>0)&(absm(val1/ddd)<.3))
			{
			ddd=(unsigned short) (ddd-val1);
			if ((j>0)&(j<limits))
				depth_out[j]=ddd;
			}
			}	
		}



pos_num=pos_num3;
pos_point=pos_point3;
num_pts=vet_pos[3][pos_num];
pos_point+=num_pts;
pos_point3=pos_point;
pos_num3=pos_point3;
pos_point3++;
pos=h2*width+w2;
for (y=h2;y<(height-1);y++,pos+=w23)
	for (x=w2;x<(width-1);x++,pos++)
		{
		if ((depth[pos]>=thr_down[c]) & (depth[pos]<thr_up[c]))
			{
			j=pos-dym-best_dx;
			ddd=depth[pos];
			
			val1=((float) best_dx)*((1084+ddd)/(x-264.46));
			val2=((float) best_dy)*((1084+ddd)/(y-205.21));

			val1=(val1+val2)/2;
			
			if ((ddd>0)&(absm(val1/ddd)<.3))
			{
			ddd=(unsigned short) (ddd-val1);
			if ((j>0)&(j<limits))
				depth_out[j]=ddd;
			}
			}	
		}

}


}

int main(int argc, char* argv[]){

int width,height,thgradC,thD,dummy_int;
double tot_time, exec_time;
FILE *inf1, *outf1;
FILE *fdepth;

struct timeval tvalBefore, tvalAfter; 

if (argc!=9)
	{
	printf("Wrong number of input parameters\n");
	printf("Usage:\n");
	printf("exec: <input file> <depth file> <output file> <width> <height> <th. grad col> <th. grad depth> <n. classes>\n");
	exit(0);
	}

inf1=fopen(argv[1],"r");
if (inf1==NULL)
	{
	printf("Error: unable to open file %s\n",argv[1]);
	exit(0);
	}
fdepth=fopen(argv[2],"r");
if (fdepth==NULL)
	{
	printf("Error: unable to open file %s\n",argv[2]);
	exit(0);
	}
outf1=fopen(argv[3],"w");
if (outf1==NULL)
	{
	printf("Error: unable to open file %s\n",argv[3]);
	exit(0);
	}

width=atoi(argv[4]);
height=atoi(argv[5]);
thgradC=atoi(argv[6]);
thD=atoi(argv[7]);
Nthr=atoi(argv[8]);
tot_time=0;


init_denoise(width,height,Nthr);

dummy_int=fread(colorM,sizeof(unsigned char),width*height,inf1);
dummy_int=fread(depthM,sizeof(unsigned short),width*height,fdepth);

fclose(inf1);
fclose(fdepth);


gettimeofday (&tvalBefore, NULL);

compute_thr(depthM,Nthr,thr_down,thr_up,width,height) ;  

#if COMP_TIME
gettimeofday (&tvalAfter, NULL);

exec_time=(tvalAfter.tv_sec - tvalBefore.tv_sec)+
	    ((double)(tvalAfter.tv_usec - tvalBefore.tv_usec)/1000000);
    
tot_time=tot_time+exec_time;

printf("theshold computation time in sec:  %3g \n",exec_time);
#endif

#if COMP_TIME
gettimeofday (&tvalBefore, NULL);
#endif

compute_sobel(colorM,depthM,maskM,gradColorM,width,height,thD);

/*{
  FILE* colM;
  FILE* depM;
  colM=fopen("colorM.msk","wb");
  fwrite(gradColorM,sizeof(unsigned char),width*height,colM);
  fclose(colM);
  depM=fopen("depthM.msk","wb");
  fwrite(maskM,sizeof(unsigned char),width*height,depM);
  fclose(depM);
  
}*/

#if COMP_TIME
gettimeofday (&tvalAfter, NULL);

exec_time=(tvalAfter.tv_sec - tvalBefore.tv_sec)+
	    ((double)(tvalAfter.tv_usec - tvalBefore.tv_usec)/1000000);
	    
tot_time=tot_time+exec_time;

printf("Sobel computation time in sec: %3g \n",exec_time);
#endif

#if COMP_TIME
gettimeofday (&tvalBefore, NULL);
#endif

compute_pixel_lines(depthM,maskM,gradColorM,depthM_denoise,width,height);

compute_pred(depthM,maskM,gradColorM,depthM_denoise,width,height);

#if COMP_TIME
gettimeofday (&tvalAfter, NULL);

exec_time=(tvalAfter.tv_sec - tvalBefore.tv_sec)+
	    ((double)(tvalAfter.tv_usec - tvalBefore.tv_usec)/1000000);
	   
tot_time=tot_time+exec_time;

printf("Prediction time in sec:  %3g \n",exec_time);
#endif


//memcpy(depthM,depthM_denoise,((width*height)*sizeof(unsigned short)));

#if COMP_TIME
gettimeofday (&tvalBefore, NULL);
#endif

/*{
  FILE* depM;
  
  depM=fopen("depth_rmv.d","wb");
  fwrite(depthM,sizeof(unsigned short),width*height,depM);
  fclose(depM);
  
}*/

/*to put erosion*/

erase_depth(depthM,maskM,depthM_denoise,width,height);

//memcpy(depthM,depthM_denoise,((width*height)*sizeof(unsigned short)));



/*{
  FILE* depM;
  
  depM=fopen("depth_rmv2.d","wb");
  fwrite(depthM,sizeof(unsigned short),width*height,depM);
  fclose(depM);
  
  FILE* colM;
  
  colM=fopen("color_rmv2.d","wb");
  fwrite(gradColorM,sizeof(unsigned char),width*height,colM);
  fclose(colM);
  
}*/

//propagate_depth(depthM,colorM,gradColorM,depthM_denoise,width,height,thgradC);

/*{
  FILE* depM;
  
  depM=fopen("depth_prop.d","wb");
  fwrite(depthM_denoise,sizeof(unsigned short),width*height,depM);
  fclose(depM);
  
}*/

gettimeofday (&tvalAfter, NULL);

#if COMP_TIME
exec_time=(tvalAfter.tv_sec - tvalBefore.tv_sec)+
	    ((double)(tvalAfter.tv_usec - tvalBefore.tv_usec)/1000000);

tot_time=tot_time+exec_time;

printf("Segmentation time in sec:  %3g \n",exec_time);

printf("-------------------------------\n");

#else

tot_time=(tvalAfter.tv_sec - tvalBefore.tv_sec)+
	    ((double)(tvalAfter.tv_usec - tvalBefore.tv_usec)/1000000);
#endif

printf("Tot time in sec:  %3g \n",tot_time);

fwrite(depthM_denoise,sizeof(unsigned short),width*height,outf1);

fclose(outf1);

free_denoise();

return 0;

}
